SystemOrganization addCategory: #TPDBZ!

Object subclass: #Guerrero
	instanceVariableNames: 'poderesAprendidos nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:53'!
AliadosMuertos 
^self aliados select:[ :unAliado | unAliado estaMuerto]! !

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:23'!
agregarAliado: unGuerrero
self aliados add: unGuerrero! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados
	^ aliados! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados: anObject
	aliados := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:50'!
aliadosVivos
^self aliados select:[:unAliado | unAliado estaVivo]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:35'!
aliadosVivosCon: unaCantidadDeEnergia
^(self aliadosVivos select: [ :unAliadoVivo | unAliadoVivo energiaSuficiente: unaCantidadDeEnergia ] ) ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:54'!
aliarseCon: unGuerrero
(self puedeAliarseCon: unGuerrero) ifTrue:[ self concretarAlianzaCon: unGuerrero ] ifFalse: [ self error: 'Imposible realizar la alianza pedida' ].! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 21:00'!
aprende: unPoder 
^(self poderesAprendidos) add unPoder ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:55'!
cantidadAliadosVivos
^ self aliadosVivos size! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia
	^ cantidadDeEnergia! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia: anObject
	cantidadDeEnergia := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 23:03'!
conAliados
|yo|
yo:= Bag new .
yo add: self.
^((self aliados),yo).
"esto se puede hacer bien, ac hcie una negrada con variables locales pero dsp lo arreglo"! !

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:36'!
concretarAlianzaCon: unGuerrero 
self agregarAliado: unGuerrero.
unGuerrero agregarAliado: self.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:31'!
energiaSuficiente: unaCantidadEnergia 
^self cantidadDeEnergia > unaCantidadEnergia ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:37'!
esBueno
^tipo esBueno.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:33'!
esDebil 
^(nivelDePelea<15000)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 22:50'!
esMasGrosoQue: unGuerrero
^( (self nivelesDePeleaConAliados)> unGuerrero nivelDePelea).! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas
	^ esferas! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas: anObject
	esferas := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:54'!
estaMuerto 
^(self estaVivo) not ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:51'!
estaVivo
^self puntosDeVida > 0! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea
	^ nivelDePelea! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea: anObject
	nivelDePelea := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 22:49'!
nivelesDePeleaConAliados
self conAliados collect:[ :unAliado | unAliado nivelDePelea] sum.! !

!Guerrero methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 20:58'!
poderesAprendidos
	^ poderesAprendidos! !

!Guerrero methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 20:58'!
poderesAprendidos: anObject
	poderesAprendidos := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 16:58'!
puedeAliarseCon: unGuerrero 
^(unGuerrero aceptaA: self) & (self aceptaA: unGuerrero)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:10'!
puedeHacer: unPoder 
^ unPoder puedeHacersePor: self! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:09'!
puntosDeVida
	^ puntosDeVida! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:10'!
puntosDeVida: anObject
	puntosDeVida := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio
	^ semillasDelHermitanio! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio: anObject
	semillasDelHermitanio := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:34'!
tiene: unaCantidad aliadosVivosCon: unaCantidadDeEnergia
^(self aliadosVivoscon: unaCantidadDeEnergia) size >= unaCantidad ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:52'!
tieneAliadosMuertos: unaCantidad 
^self aliadosMuertos size >= unaCantidad ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 21:06'!
tieneAprendido: unPoder 
^ (self poderesAprendidos)  includes: unPoder ! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo
	^ tipo! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo: anObject
	tipo := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje
	^ traje! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje: anObject
	traje := anObject! !

Guerrero subclass: #Monstruo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Monstruo methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 16:57'!
aceptaA: unGuerrero 
^true.! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Saiyajin methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 17:00'!
aceptaA: unGuerrero
^(unGuerrero esMasGrosoQue: self not)! !

Guerrero subclass: #Terricola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:58'!
aceptaA: unGuerrero
^(unGuerrero esBueno & (self meEntra: unGuerrero))! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 18:09'!
aliadosDebiles
^self aliados select: [ :unAliado | unAliado esDebil] ! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
cantAliadosDebiles
^self aliadosDebiles size! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
meEntra: unGuerrero
^(unGuerrero esDebil & (self cantAliadosDebiles >5)) not! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:16'!
puedeHacer: unPoder
^super puedeHacer: unPoder &  (unPoder energiaConsumida: self) <500 ! !

Object subclass: #PoderColectivo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:04'!
energiaConsumida: unGuerrero
^200! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 21:02'!
puedeHacersePor: unGuerrero
^(unGuerrero tieneAprendido: self) & (unGuerrero energiaSuficiente: 200) &  (unGuerrero tiene:  5 aliadosVivosCon: (self energiaAlidos))! !

Object subclass: #PoderLiviano
	instanceVariableNames: 'puntosDeAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:03'!
energiaConsumida: unGuerrero
^0! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 21:03'!
puedeHacersePor: unGuerrero
^ (unGuerrero tieneAprendido: self) & (unGuerrero energiaSuficiente: 50).! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque
	^ puntosDeAtaque! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque: anObject
	puntosDeAtaque := anObject! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 19:36'!
puntosDeAtaquePara: unGuerrero 
^ self puntosDeAtaque ! !

Object subclass: #PoderPotente
	instanceVariableNames: 'potencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:34'!
energiaConsumida: unGuerrero 
^ unGuerrero cantidadDeEnergia * 0.25! !

!PoderPotente methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 19:39'!
potencia
	^ potencia! !

!PoderPotente methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 19:39'!
potencia: anObject
	potencia := anObject! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 21:03'!
puedeHacersePor: unGuerrero
^ (unGuerrero tieneAprendido: self) ! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 19:38'!
puntosDeAtaquePara: unGuerrero
^ (unGuerrero nivelDePelea )/ 500 * (self potencia)! !

Object subclass: #PoderVengativo
	instanceVariableNames: ''
	classVariableNames: 'energiaQueConsume'
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderVengativo class methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 21:27'!
energiaQueConsume
	^ energiaQueConsume! !

!PoderVengativo class methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 21:27'!
energiaQueConsume: anObject
	energiaQueConsume := anObject! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 21:30'!
energiaConsumida: unGuerrero
^ (self class) energiaQueConsume! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 21:28'!
puedeHacercePor: unGuerrero
^(unGuerrero tieneAprendido: self) & (unGuerrero energiaSuficiente: ((self class) energiaQueConsume) )& (unGuerrero tieneAliadosMuertos: (self aliadosMuertosNecesarios)) & (unGuerrero cantidadAliadosVivos >= 1)! !

Object subclass: #TipoBueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^true! !

Object subclass: #TipoMalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^false! !

Object subclass: #Traje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Traje methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/14/2013 22:43'!
portador: unGuerrero suTrajeResiste: unAtaque
	^(unAtaque * 0,90).! !

Traje subclass: #TrajeEntrenamiento
	instanceVariableNames: 'ataquesRecibidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:46'!
ataquesRecibidos
	^ ataquesRecibidos! !

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:46'!
ataquesRecibidos: anObject
	ataquesRecibidos := anObject! !

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:55'!
portador: unGuerrero suTrajeResiste: unAtaque
	ataquesRecibidos := ataquesRecibidos +1.
	unGuerrero cantidadDeEnergia: ((unGuerrero cantidadDeEnergia) -20).
	(ataquesRecibidos =3) ifTrue: [ self ataquesRecibidos: 0.
									unGuerrero nivelDePelea: ((unGuerrero nivelDePelea) + 100) .] .
	^(unAtaque * 0,90).! !

Traje subclass: #TrajeEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TrajeEspecial methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/14/2013 22:42'!
portador: unGuerrero suTrajeResiste: unAtaque
	^(unAtaque * 0,90)-20.! !
